﻿package de.spielzeugz.test
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.*;
	
	import net.hires.debug.Stats;
	
	
	[SWF(width='1000',height='560',frameRate='30',backgroundColor='0x000000')]
	
	/**
	 * DisplayObjects
	 * 
	 * Draws vector shapes into MovieClips once, then animates the MovieClips.
	 * 
	 * @author <a href="mailto:daniel.puhe@spielzeugz.de">Dan</a>
	 */
	public class FlashShapesDisplayObjects extends Sprite
	{
		protected var numMovers           :int;
		protected var moverSize           :int;
		protected var movers              :Array;
		
		protected var stageW              :Number;
		protected var stageH              :Number;
		
		
		
		public function FlashShapesDisplayObjects()
		{
			init();
		}
		
		
		public function init() :void
		{
			numMovers = parseInt( loaderInfo.parameters.numObjects ) || 150;
			moverSize = parseInt( loaderInfo.parameters.objectSize ) || 200;			
			
			stage.align = "TL";
			stage.scaleMode = "noScale";			
			
			resize( null );
			
			movers = [];
			
			var i :int = numMovers;
			while ( i-- )
			{
				// create a moving object with random velocity
				var m :MovieClip = new MovieClip();
				m.x  = Math.random() * stageW;
				m.y  = Math.random() * stageH;
				m.vX = 10 - Math.random() * 20;
				m.vY = 10 - Math.random() * 20;
				
				
				var halfSize    :Number = moverSize * .5;
				var quarterSize :Number = moverSize * .25;
				var color :uint = 0xFFFFFF * Math.random();
				
				m.graphics.beginFill( color );
				m.graphics.drawRect( 0 , 0 , moverSize , moverSize );
				
				m.graphics.beginFill( color * .5 );
				m.graphics.drawCircle( halfSize , halfSize , halfSize );
				
				m.graphics.beginFill( color * .25 );
				m.graphics.drawRect( quarterSize , quarterSize , halfSize , halfSize );
				
				m.graphics.beginFill( color * .12 );
				m.graphics.drawCircle( halfSize , halfSize , quarterSize );			
				
				
				movers[i] = m;
				addChild( m );
			}
			
			addChild( new Stats() );
			
			stage.addEventListener( Event.RESIZE , resize );
			stage.addEventListener( Event.ENTER_FRAME , run );
		}
		
		
		protected function run( e :Event ) :void
		{
			var i :int = numMovers;
			while ( i-- )
			{
				var m :MovieClip = movers[i];
				
				var nextX :Number = m.x + m.vX;
				var nextY :Number = m.y + m.vY;
				
				
				// simple stage bounds collision detection
				if( nextX + moverSize > stageW )
				{
					nextX = stageW - moverSize;
					m.vX *= -1;
				}
				else if( nextX < 0 )
				{
					nextX = 0;
					m.vX *= -1;
				}
				
				if( nextY + moverSize > stageH )
				{
					nextY = stageH - moverSize;
					m.vY *= -1;
				}
				else if( nextY < 0 )
				{
					nextY = 0;
					m.vY *= -1;
				}
				
				m.x = nextX;
				m.y = nextY;
			}
		}
		
		
		protected function resize( e :Event ) :void
		{
			stageW = stage.stageWidth;
			stageH = stage.stageHeight;
		}
		
		
	}
}