﻿package de.spielzeugz.test
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.*;
	
	import net.hires.debug.Stats;
	
	
	[SWF(width='1000',height='560',frameRate='30',backgroundColor='0x000000')]
	
	/**
	 * Graphics
	 * 
	 * Draws vector shapes continuously each frame.
	 * 
	 * @author <a href="mailto:daniel.puhe@spielzeugz.de">Dan</a>
	 */
	public class FlashShapesGraphics extends Sprite
	{
		protected var numMovers           :int;
		protected var moverSize           :int;
		protected var movers              :Array;
		protected var halfSize            :Number;
		protected var quarterSize         :Number;
		protected var stageW              :Number;
		protected var stageH              :Number;
		
		
		
		public function FlashShapesGraphics()
		{
			init();
		}
		
		
		public function init() :void
		{
			numMovers = parseInt( loaderInfo.parameters.numObjects ) || 150;
			moverSize = parseInt( loaderInfo.parameters.objectSize ) || 200;
			
			stage.align = "TL";
			stage.scaleMode = "noScale";			
			
			resize( null );
			
			halfSize    = moverSize * .5;
			quarterSize = moverSize * .25
			
			movers = [];
			
			var i :int = numMovers;
			while ( i-- )
			{
				// create a moving object with random velocity
				var m :Object = {};
				m.x  = Math.random() * stageW;
				m.y  = Math.random() * stageH;
				m.vX = 10 - Math.random() * 20;
				m.vY = 10 - Math.random() * 20;
				m.color = 0xFFFFFF * Math.random();
				movers[i] = m;
			}
			
			addChild( new Stats() );
			
			stage.addEventListener( Event.RESIZE , resize );
			stage.addEventListener( Event.ENTER_FRAME , run );
		}
		
		
		protected function run( e :Event ) :void
		{
			graphics.clear();
			
			var i :int = numMovers;
			while ( i-- )
			{
				var m :Object = movers[i];
				
				var nextX :Number = m.x + m.vX;
				var nextY :Number = m.y + m.vY;
				
				
				// simple stage bounds collision detection
				if( nextX + moverSize > stageW )
				{
					nextX = stageW - moverSize;
					m.vX *= -1;
				}
				else if( nextX < 0 )
				{
					nextX = 0;
					m.vX *= -1;
				}
				
				if( nextY + moverSize > stageH )
				{
					nextY = stageH - moverSize;
					m.vY *= -1;
				}
				else if( nextY < 0 )
				{
					nextY = 0;
					m.vY *= -1;
				}
				
				m.x = nextX;
				m.y = nextY;
				
				
				// draw nice shapes
				graphics.beginFill( m.color );
				graphics.drawRect( nextX , nextY , moverSize , moverSize );
				
				graphics.beginFill( m.color * .5 );
				graphics.drawCircle( nextX + halfSize , nextY + halfSize , halfSize );
				
				graphics.beginFill( m.color * .25 );
				graphics.drawRect( nextX + quarterSize , nextY + quarterSize , halfSize , halfSize );
				
				graphics.beginFill( m.color * .12 );
				graphics.drawCircle( nextX + halfSize , nextY + halfSize , quarterSize );
			}
		}
		
		
		protected function resize( e :Event ) :void
		{
			stageW = stage.stageWidth;
			stageH = stage.stageHeight;
		}
		
		
	}
}